#ifndef NPGLVEC_H
#define NPGLVEC_H

struct np_glob_vec
{
  /// step id
  long istep;


  // Following pointers are not allocated, 
  // they are used as references to arrays allocated somewhere else

  ///  nodal values
  double *lhs;
  ///  time derivatives of nodal values
  double *tdlhs;
  ///  right hand side
  double *rhs;

  // Following pointers to arrays are allocated 
  // allocation of vectors  

  ///  vector of prescribed fluxes (right hand side)
  double *f;
  ///  predictor
  double *d;
  ///  auxiliary vector
  double *p;
  ///  auxiliary vectors
  double *fb,*fi;

  /// Default constructor 
  np_glob_vec();
  /// function allocates vectors lhs, tdlhs, rhs, f, d, p
  void alloc(long n);
  /// function allocates vectors fb, fi
  void alloc_aux(long n);
  /// function deallocates vectors lhs, tdlhs, rhs, f, d, p
  void dealloc();
  /// Destructor deallocates vectors lhs, tdlhs, rhs, f, d, p
  ~np_glob_vec();
};

#endif
