#include "transbclc.h"

transbclc::transbclc (void)
{
  // number of load cases
  nlc=0;
  //  load case pointers
  lc=NULL;
}

transbclc::~transbclc (void)
{
  delete [] lc;
}

/**
   function reads data about load cases
   
   @param in - pointer to input file
   
   JK
*/
void transbclc::read (XFILE *in)
{
  long i;
  
  xfscanf (in,"%k%ld","number_of_load_cases",&nlc);
  lc = new loadcaset [nlc];
  for (i=0;i<nlc;i++){
    lc[i].read (in,i);
  }
}


/**
   function prints data about load cases
   
   @param out - pointer to output file
   
   TKr
*/
void transbclc::print (FILE *out)
{
  long i;
  
  fprintf(out,"\n\n## boundary conditions:\n");
  fprintf (out,"\n");
  fprintf (out,"\n %ld #number of loadcases",nlc);
  for (i=0;i<nlc;i++){
    lc[i].print (out,i);
  }
}

/**
   function searches for elements with nodes where source is defined
   
   JK, 25.6.2005
*/
void transbclc::elemsource ()
{
  long i;
  
  for (i=0;i<nlc;i++){
    lc[i].elemsource ();
  }
  
}

